package svc

import (
	"git.chillcy.com/golang/chillcy/pkg/etcd"
	"git.chillcy.com/golang/colorway/internal/pkg/database"
	"git.chillcy.com/golang/colorway/internal/rpc/internal/config"
)

type ServiceContext struct {
	Config          config.Config
	DatabaseManager *database.Manager
}

func NewServiceContext(c config.Config) *ServiceContext {
	etcd.Init(etcd.Env(c.Mode))
	// todo dsn etcd
	dsn := "root:root@tcp(127.0.0.1:3306)/colorway?charset=utf8mb4&collation=utf8mb4_unicode_ci&parseTime=true&loc=Local"
	manager, err := database.NewManager(dsn)
	if err != nil {
		panic(err)
	}
	return &ServiceContext{
		Config:          c,
		DatabaseManager: manager,
	}
}
